Bug 491567 - httpd crashed on HUP for log rotation with undefined symbol
httpd crashed on HUP for log rotation with undefined symbol
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: httpd (Show other bugs)
11
All Linux
low Severity medium
: ---
: ---
Assigned To: Joe Orton
Fedora Extras Quality Assurance
:
: 492753 521520 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-03-22 20:01 EDT by Nathan G. Grennan
Modified: 2010-02-26 22:40 EST (History)
12 users (show)

See Also:
Fixed In Version: httpd-2.2.14-1.fc11
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-12-09 23:17:27 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Nathan G. Grennan 2009-03-22 20:01:38 EDT
Description of problem:
  Weekly log rotation happened this morning(Sunday), and httpd died. The error in the log is below. Interestingly, service httpd start worked just fine hours later when httpd was found to be down.

[Sun Mar 22 04:48:23 2009] [notice] SIGHUP received.  Attempting to restart
httpd: Syntax error on line 188 of /etc/httpd/conf/httpd.conf: Cannot load /etc/httpd/modules/mod_proxy.so into serv
er: /etc/httpd/modules/mod_proxy.so: undefined symbol: ap_timeout_parameter_parse


  Log rotation happened at roughly 4:48am, and httpd was updated at 4:01pm the day before.

  I suspected the rpm scripts, but comparing httpd-2.2.10-2.x86_64 to httpd-2.2.11-2.fc10.x86_64 the sha1sums match.

Version-Release number of selected component (if applicable):
httpd-2.2.11-2.fc10.x86_64

How reproducible:
Unknown

Steps to Reproduce:
1. Update to httpd-2.2.11-2.fc10.x86_64
2. /bin/kill -HUP `cat /var/run/httpd.pid 2>/dev/null` 2> /dev/null
  
Actual results:
httpd dies

Expected results:
httpd keeps running

Additional info:
Comment 2 Joe Orton 2009-03-23 09:39:24 EDT
Ah, sorry.  This happens with SIGHUPs across minor version updates sometimes.
Comment 3 Joe Orton 2009-03-23 09:40:51 EDT
(hit enter too quickly)

The problem is with a SIGHUP after an upgrade, the 2.2.10 httpd tries to load the 2.2.11 modules, but the 2.2.11 modules depend on functions in the new httpd.
Comment 4 Nathan G. Grennan 2009-03-23 13:01:08 EDT
I thought this kind of thing was a known issue and services were set to be restarted on update to avoid it. I have run into the opposite of this problem with mysqld. I update it, and it restarts unexpectedly. So I see how it cuts both ways, but crash on log rotation is definitely not good.

I see conditional restarts on postuninstall with openssh, bind, and mysql.
Comment 5 Gwyn Ciesla 2009-03-30 09:19:06 EDT
This hit me too.  I'd have expected a restart at update, too.
Comment 6 Joe Orton 2009-04-02 04:03:44 EDT
I don't consider restarts on upgrades feasible.  When do you want to do it?

1. on update of the httpd package
2. on update of the httpd package or any httpd module
3. on update of the httpd package, any httpd module, or any dependant library
4. on update of the httpd package, any httpd module, any dependant library, or any web app (see also bug 491137)
Comment 7 Gwyn Ciesla 2009-04-02 08:43:46 EDT
1. Makes sense to me, as I've come to expect it on other daemon rpms.
2. Also makes sense.
3. Such as. . .
4. Should be advised in the bodhi update on an app-by-app basis if needed, as most wouldn't need a restart of httpd.
Comment 8 Jon Baker 2009-05-24 12:09:54 EDT
2 weeks in a row had the same happen after running a yum update.  Restarting httpd manually works, but then the second week sighup failed again with the same "undefined symbol: ap_timeout_parameter_parse" error.  We had updated to 2.2.11-2 on the 18th via yum, after that each log rotate has crashed apache.
Comment 9 Joe Orton 2009-08-18 08:04:21 EDT
*** Bug 492753 has been marked as a duplicate of this bug. ***
Comment 10 Joe Orton 2009-09-07 08:41:15 EDT
*** Bug 521520 has been marked as a duplicate of this bug. ***
Comment 11 Joe Orton 2009-09-07 08:44:42 EDT
So actually now %posttrans scriptlets exist, it would probably make sense to have a %posttrans scriptlet which did a condrestart after an upgrade of httpd, at minimum.
Comment 12 Nadav Har'El 2009-09-07 09:05:05 EDT
I can also report that I had this bug - httpd crashed an didn't restart after a log rotate; The log ends with:

[Sun Sep 06 03:06:19 2009] [notice] SIGHUP received.  Attempting to restart
httpd: Syntax error on line 171 of /etc/httpd/conf/httpd.conf: Cannot load /etc/httpd/modules/mod_include.so into server: /etc/httpd/modules/mod_include.so: undefined symbol: ap_escape_html2

Starting httpd again (service httpd start) works without a problem.
Comment 13 Jon Baker 2009-09-08 10:05:35 EDT
Had been working fine for me until the most recent httpd update to 2.2.13-1.fc11 last week, on Sunday I also received the undefined symbol: ap_escape_html2 - and, like nyh, restarting manually worked without issue.  This happened on two different servers.

Oddly enough, I have two other servers with the same httpd version that did not have any problems with the logrotate.
Comment 14 Joe Orton 2009-09-08 10:18:06 EDT
See comment 3 for an explanation of why this sometimes happens with updates.

If you restarted httpd between updating the package and the logrotate run, then, you won't see the problem.

The problem only occurs if you don't restart httpd before logrotate runs.
Comment 15 Andreas Jaehnigen 2009-10-25 17:49:10 EDT
This bug hit me too after an update to Apache 2.2.14 on CentOS 5.4
Restarting manually, of course, was possible.
The log ended with:
[Sun Oct 25 01:37:03 2009] [notice] SIGHUP received.  Attempting to restart
httpd: Syntax error on line 163 of /etc/httpd/conf/httpd.conf: Cannot load /etc/httpd/modules/mod_include.so into server: /etc/httpd/modules/mod_include.so: undefined symbol: ap_escape_html2
Comment 16 Bug Zapper 2009-11-18 06:34:51 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 17 Nadav Har'El 2009-11-18 06:49:03 EST
This bug is *not* specific to Fedora 10, and also existed in Fedora 11. Someone, please change the "version" of this bug so it doesn't get removed!
Comment 18 arth 2009-12-02 12:18:43 EST
Would this not be fixed if httpd and any packages providing modules for httpd did something like this in the postinstall section?

service httpd status >/dev/null && service httpd graceful
Comment 19 Fedora Update System 2009-12-03 10:57:18 EST
httpd-2.2.14-1.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/httpd-2.2.14-1.fc11
Comment 20 Joe Orton 2009-12-03 10:59:39 EST
Please test out the 2.2.14-1 package when it hits updates-testing and post feedback at the bodhi link above (and here if you like).  This update should resolve this issue.
Comment 21 Fedora Update System 2009-12-03 11:28:29 EST
httpd-2.2.14-1.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/httpd-2.2.14-1.fc10
Comment 22 Fedora Update System 2009-12-04 18:35:12 EST
httpd-2.2.14-1.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update httpd'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-12604
Comment 23 Fedora Update System 2009-12-04 19:07:17 EST
httpd-2.2.14-1.fc11 has been pushed to the Fedora 11 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update httpd'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F11/FEDORA-2009-12747
Comment 24 Fedora Update System 2009-12-09 23:17:16 EST
httpd-2.2.14-1.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 25 Fedora Update System 2010-02-26 22:40:21 EST
httpd-2.2.14-1.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.